layui.use([ 'form', 'element', 'table','laydate' ], function() {
	var form = layui.form;
	var element = layui.element;
	var table = layui.table;
	var resultFieldList;
	var condition;
	globalutil.render(".zszmcy-search");
	
	// 获取配置的结果显示字段
	function getConfigedResultFieldList(){
		debugger
		com.ajax({
			url : config["url"]["select-queryCheckedList-zscy"], //获取已配置字段数据  ZSCY_VIEW_QUERY_BINDED_ZSCYFIELDLIST
			type : "POST",
			dataType : "JSON",	
			success : function(rst){
				if(rst.code == 200){
					if(com.isEmptyObject(rst) || com.isEmptyObject(rst.data) ){ 
						resultFieldList = initDefaultResultField();
					}else{
						resultFieldList = rst.data;
						resultFieldList.unshift({CODE: "CXID",NAME: "查询ID"});
					}
				}else{
					resultFieldList = initDefaultResultField();
				}
			}
		})
	};
	
	function initDefaultResultField() {
		var defaultResultField = [
			{ CODE: 'CQZSBH', NAME: '证书序列号' }
			, { CODE: 'BDCQZH', NAME: '不动产权证号' }
			, { CODE: 'BDCDYH', NAME: '不动产单元号' }
			, { CODE: 'QLR', NAME: '权利人' }
			, { CODE: 'FWYTMC', NAME: '房屋用途' }
			, { CODE: 'MJ1', NAME: '面积' }
			, { CODE: 'ZL', NAME: '坐落' }
			, { CODE: 'QLLX', NAME: '权利类型' }
			, { CODE: 'QLXZ', NAME: '权利性质' }
			, { CODE: 'BDCZT', NAME: '不动产状态' }
		]
		return defaultResultField;
	};
	
	form.on('submit(zszmcy-submit)', function (data) {
		var sublayer = layer.load();
		var condition = {};
		var formData = data.field;
		condition = formData;
//		if(!$.isEmptyObject(model.currentUser)){
//			condition.CXR = model.currentUser.USER_INFO.USER_NAME;
//		}else{
//			condition.CXR = "";
//		}
//		model.condition = condition;
//		if (model.sfkqqy == '0') {
//			var checkRst = true;
//			if (model.sfkqdl == '0') {//开启登录
//				checkRst = service.checkCode();
//			}
//			if (checkRst) {
//				if (formData.city == "" || formData.city == "-1") {
//					condition.QXDM = formData.province;
//				} else {
//					condition.QXDM = formData.area == "" || formData.area == "-1" ? formData.city : formData.area;
//				}
//			}
//
//		}
		zszmcyService(formData);
		layer.close(sublayer);
		return false;
	});
	
	/** 查验结果 */
	function zszmcyService (condition) {
		var sublayer = layer.load(2);
		try {
			// 获取查询字段
			if (!!!resultFieldList) {
				getConfigedResultFieldList();
			}
			renderResultTable();

			// 查询
			com.ajax({
				url : config["url"]["select-queryZSCYANDZMCY"],
				type : "POST",
				dataType : "json",
				data : {
					QLRMC : condition.USER_NAME,
					ZJHM : condition.ZJHM,
					QXDM : condition.QXDM,
					BDCQZH : condition.ZSZMH
				},
				success : function(data){
					if (data.code != 200) {
						if (com.isEmptyObject(data.data)) {
							layui.layer.alert('服务器开小差了，请稍后重试');
						} else {
							layui.layer.alert(data.data.EX);
						}
						layer.close(sublayer);
					} else {
						if (com.isEmptyObject(data.data)) {
							layui.layer.alert(data.msg);
						} else {
							try {
								// 处理查询结果的字段key值 -- 全部转为大写
								var resultData = {};
								com.each(data.data, function (key, val) {
									key = key.toUpperCase();
									resultData[key] = val;
								})
								resultData.CXID = data.data.CXID;
								// 循环匹配查询结果字段
								com.each(resultFieldList, function (i, item) {
									var code = item.CODE.toUpperCase()
										, val = '';
									if (com.inArray(code, ['BDCZT', 'ZT']) != -1) {
										val = ['已登记', resultData.DYCOUNT > 0 ? '已抵押' : '未抵押', resultData.CFCOUNT > 0 ? '已查封' : '未查封'].join('、');
										val = '<span style ="color: #F44336;">' + val + '</span>';
									}
									else if (com.inArray(code, ['SFDY']) != -1) {
										val = resultData.DYCOUNT > 0 ? '<span style ="color: #D0021B;">已抵押</span>' : '无抵押';
									}
									else if (com.inArray(code, ['SFCF']) != -1) {
										val = resultData.CFCOUNT > 0 ? '<span style ="color: #D0021B;">已查封</span>' : '无查封';
									}
									else if (com.inArray(code, ['SFYY']) != -1) {
										val = resultData.YYCOUNT > 0 ? '<span style ="color: #D0021B;">已异议</span>' : '无异议';
									}
									else if (com.inArray(code, ['SFYG']) != -1) {
										val = resultData.YGCOUNT > 0 ? '<span style ="color: #D0021B;">已预告</span>' : '无预告';
									}
									else if (com.inArray(code, ['SFYD']) != -1) {
										val = resultData.YDCOUNT > 0 ? '<span style ="color: #D0021B;">已预抵</span>' : '无预抵';
									}
									else if (com.inArray(code, ['FWYTMC', 'YT']) != -1) {
										val = resultData.YT;
									}
									else {
										val = resultData[code];
									}
									com('#CXJG_' + code).html(val);
								})
								com(".zszmcy-search").hide();
								com("#cyJg").show();
							} catch (e) {
								layui.layer.alert('查询处理出错，请联系中心人员');
							} finally {
								layer.closeAll();
							}
						}
					}
				}
			});
		} finally {
			layer.close(sublayer);
		}
	};
	
	function renderResultTable(){
		var rHtml = [];
		com.each(resultFieldList, function (i, item) {
			rHtml.push('<tr><td class="showText">' + item.NAME + '</td><td class="showValue" id="CXJG_' + item.CODE + '"></td></tr>');
		})
		com('#searchResultMainWrapper').html(rHtml.join(''));
//		initMzsmHtml();
	};
	
//	function initMzsmHtml(){
//		var mzHtml = [];
//		var mzsm_DATA = kq.getCache(["MZSM"]).MZSM;
//		if(mzsm_DATA && mzsm_DATA.length>0){
//			mzHtml.push('<font>免责申明</font></br>');
//			for(var i = 0; i<mzsm_DATA.length;i++){
//				mzHtml.push('<font>'+mzsm_DATA[i].bz+'</font></br>');
//			}
//			com('#mzsm').html(mzHtml.join(''));
//		}
//	}
	
	com('#downpagebtn').off("click").on("click",function(){
		 var qlr = com("#CXJG_QLR").html();
		 var zjhm = com("#CXJG_QLRZJHM").html();
		 com("#CXJG_QLR").html(condition.USER_NAME);
		 com("#CXJG_QLRZJHM").html(condition.ZJHM);
		 document.getElementById("tpsy").style.display = 'block';
		 // 要导出pdf的节点
		 var elements = document.getElementsByClassName("resultShowDiv"); // 需要转换的页面节点
		 var imgMap = new Map();
		 for (var index = 0; index < elements.length; index++) {
			 var mapIndex = index;
			 html2canvas(elements[index], {
				 useCORS: true, // 是否允许网页中img元素跨域，这个设置需要img元素支持及服务器支持
				 scale: 2, // 这个影响生成图片的清晰度
				 background: "#F5F5F5" // 背景
			 }).then((canvas) => {
				 var img = new Image();
				 img.width = canvas.width;
				 img.height = canvas.height;
				 img.src = canvas.toDataURL('image/jpeg', 1.0);	  
				 imgMap.set(mapIndex, img); // 按照顺序保存图片

				 if(imgMap.size == elements.length) { // 当所有图片都转化完毕，则进行保存操作
					 var pdf = new jsPDF('', 'pt', 'a4');
					 for(var i = 0; i < imgMap.size; i++) {
						 // canvas尺寸
						 var canvasWidth = imgMap.get(i).width;
						 var canvasHeight = imgMap.get(i).height;
						 var pageData = imgMap.get(i).src;
						 addOneImg(pdf, pageData, canvasWidth, canvasHeight);
						 if(i < imgMap.size-1) {
							 pdf.addPage(); // 如果还有图片未添加到pdf,则增加一个页面
						 }
					 }
					 document.getElementById("tpsy").style.display = 'none';
					 com("#CXJG_QLR").html(qlr);
					 com("#CXJG_QLRZJHM").html(zjhm);
					 // 所有图片添加完毕，保存
					 pdf.save("证书查验.pdf");
				 }
			 });
		 };
		 // img转化为pdf并保存
		 var addOneImg = function (pdf, pageData, canvasWidth, canvasHeight) {
			 // a4纸的尺寸[595.28,841.89]
			 var a4Width = 595.28;
			 var a4Height = 841.89;

			 // html页面生成的canvas在pdf中图片的宽高
			 var imgWidth = a4Width;
			 var imgHeight = a4Width / canvasWidth * canvasHeight;

			 // 一页pdf显示html页面生成的canvas高度;
			 var pageHeight = canvasWidth / a4Width * a4Height;

			 addPages(pdf, pageData, 0, imgWidth, imgHeight, canvasHeight, pageHeight, a4Height);
		 }

		 // 递归的方式对页面进行截取并添加到pdf中
		 var addPages = function (pdf, pageData, position, imgWidth, imgHeight, canvasHeight, pageHeight, a4Height) {
			 pdf.addImage(pageData, 'JPEG', 0, position, imgWidth, imgHeight)
			 // 减去已经绘制的区域
			 canvasHeight -= pageHeight;
			 position -= a4Height;
			 // 当还有内容未生成pdf，则新加页面，并添加图片
			 if (canvasHeight > 0) {
				 pdf.addPage();
				 addPages(pdf, pageData, position, imgWidth, imgHeight, canvasHeight, pageHeight, a4Height);
			 }
		 }
	});
})