function Process(){
	if(!setting || !setting.process){
		layui.layer.alert("未找到正确的业务进度节点配置");
		return;
	}
	var options = setting.process,
		target = com("div.process-step-nav-body"),
		targetLength = 0,
		current_index = 0,
		that = this;
	this.overall = {};
	this.success = false;
	this.render = function(){
		this.success = false;
		options = setting.process;
		target.html("");
		if(options.columns && options.columns.length > 0){
			var columns = options.columns;
			targetLength = columns.length;
			for(var i = 0 ; i < columns.length ; i++ ){
				var column = columns[i];
				target.append(getContent("${ContextPath}/GRSB/common/process/process-block.html",{
					DJLX_NAME : column.name,
					STEP_INDEX : i + 1,
					STEP_URL : column.url
				}));
			}
			this.initScroll();
			this.success = true;
		}
	};
	this.getIndex = function(){
		return current_index;
	}
	this.renderSetting = function(opt){
		this.success = false;
		if(!opt){
			layui.layer.alert("renderSetting未找正确传参");
			return;
		}
		if(!opt.djlx){
			layui.layer.msg('配置错误，登记类型不可为空', {offset: 'auto', time:2000});
			return;
		}else if(!opt.bdclx){
			layui.layer.msg('配置错误，不动产类型不可为空', {offset: 'auto', time:2000});
			return;
		}else{
			//根据登记类型，产权来源，不动产类型，房屋用途获取不同的配置，加载配置js并刷新process
			var setting_url = opt.djlx + 
				(opt.cqly != null && opt.cqly != '' ? "-" + opt.cqly : '') + 
				"-" + opt.bdclx + 
				(opt.fwyt != null && opt.fwyt != '' ? "-" + opt.fwyt : '');
			com.ajax({
				url : "${ContextPath}/GRSB/settings/"+setting_url+".js",
				type : "GET",
				dataType : "text",
				async : false,
				cache : true,
				success : function(data){
					var x = document.createElement("SCRIPT");
					var t = document.createTextNode(data);
					x.appendChild(t);
					com(".process-script-setting").html(x);
					that.render();
				},
				error : function(e){
					if(e.status == 404){
						layui.layer.msg('业务流程开发中...', {offset: 'auto', time:2000});
						return;
					}
				}
			})
		}
	};
	this.initScroll = function(){
		com(document).off("scroll").on("scroll",function(){
			var top = com(".process-step-nav-line")[0].getBoundingClientRect().top;
			if(top > 0){
				com(".process-step-nav-position-fixed").removeClass("process-step-nav-position-fixed").addClass("process-step-nav-position-relative");
			}else{
				com(".process-step-nav-position-relative").removeClass("process-step-nav-position-relative").addClass("process-step-nav-position-fixed");
			}
		})
	};
	this.prev = function(){
		if(!this.success) return;
		current_index--;
		this.select(current_index);
	};
	this.next = function(){
		if(!this.success) return;
		current_index++;
		this.select(current_index);
	};
	this.select = function(index){
		if(!index || index == ''){
			layui.layer.msg('当前的流程节点跳转设置有误(空设置)', {offset: 'auto', time:2000});
			return;
		}
		index = index > targetLength ? targetLength + 1 : index;
		current_index = index;
		com(".process-step-nav-item.active").removeClass("active");
		if(index > targetLength){
			com(".process-step-nav-item").addClass("active");
		}
		var target = com(".process-step-nav-item.process-step-" + index);
		var moduleStep = com(".process-step modules-iframe");
		var url = target.attr("step-url");
		target.addClass("active").prevAll(".process-step-nav-item").addClass("active");
		var curr_module = moduleStep.find("div.modules-step-" + index);
//		if(url && curr_module.length == 0){
//			
//		}else{
//			com("div.modules-step").hide();
//			curr_module.show();
//		}
		
		com("div.modules-step").remove();
		if(!url || url == ''){
			layui.layer.msg('未找到正确的配置页面地址', {offset: 'auto', time:2000});
			return ;
		}
		
		var moduleContent = getContent(url,{});
		com("div.modules-step").hide();
		moduleStep.append('<div class="modules-step modules-step-'+index+'">'+moduleContent+'</div>');
		
		if(!this.overall["ID"]) return;
		com.ajax({
			url : config["url"]["process-setProcess"],
			type : "POST",
			contentType: "application/json;charset=UTF-8",
			dataType : "json",
			data : JSON.stringify({
				ID : this.overall["ID"],
				index : index
			}),
			async : true,
			success : function(rst){
				if(rst.code != "200"){
					layui.layer.alert(rst.msg); 
				}
			}
		})
	};
//	function changeFrameHeight(frame){
//	    frame.height = frame.contentWindow.document.documentElement.clientHeight;
//	}
//	function addResizeListener(frame){
//		var iframeWindow = frame.contentWindow;
//		iframeWindow.onresize = function(){
//			changeFrameHeight(frame);
//		};
//	}
	function getContent(url,data){
		var result = "";
		com.ajax({
			url : url,
			data : data,
			contentType: "text/html;charset=UTF-8",
			type : "GET", //使用GET会乱码，是由于直接传了中文到后台，Tomcat没设置编码导致的
			dataType : "text",
			async : false,
			cache : true,
			load : false,
			success : function(data){
				result = data;
			}
		})
		return result;
	}
	this.render();
}