layui.use([ 'form', 'element', 'table' ], function() {
	var REC_ID = globalutil.GetQueryString("ID");
	var users_qlr = new UserInfo({
		title : '权利人（买方）信息',
		itemid : "qlr",
		isCanAddUser : true
	});
	var users_ywr = new UserInfo({
		title : '义务人（卖方）信息',
		itemtype : "ywr",
		isCanAddUser : false
	});
	function init(){
		users_qlr.addUserItem({isCanDelete : false});
		users_ywr.addUserItem({isCanDelete : false});
	}
	//根据数据初始化界面
	function initData(data){
		for(var i = 0 ; i < data.length ; i++){
			var tmp = data[i];
			//区分权利人、义务人，并渲染模板
			if(tmp.BZ == "0"){
				tmp["isCanDelete"] = (i == 0 ? false : true);
				tmp["disabled"] = {
					GYFS : tmp.GYFS != '0' ?　'0' : ''
				};
				users_qlr.addUserItem(tmp);
			}else{
				tmp["isCanDelete"] = false;
				tmp["disabled"] = {
					QLRMC : "true",
					ZJLX : "true",
					ZJHM : "true",
					QLRLX : "true",
					XB : "true",
					GYFS : "0||1||2",
					QLBL : "true"
				};
				users_ywr.addUserItem(tmp);
			}
		}
		//义务人不可能为空，因为是从不动产拿过来的，如果是空就是错误数据
		//如果权利人为空，自动加载一个模板
		if(users_qlr.getSize() == 0){
			users_qlr.addUserItem({isCanDelete : false,BZ : '0'});
		}
		//信息采集的权利人数据包装
		bdccollection["userinfo"] = function(){
			var qlrList = users_qlr.getDataList(),
				ywrList = users_ywr.getDataList();
			var flag = true;
			//权利人不可为空，前面已经自动加载一个模板了，并且这个模板是不可删除的
			if(qlrList.length == 0){
				layui.layer.alert("系统错误，权利人列表不可为空");
				return false;
			}if(qlrList.length == 1 && qlrList[0].gyfs != "0"){	//如果共有情况不是单独所有
				users_qlr.scrollOn();
				layui.layer.msg("当前仅有一条权利人信息，请选择单独所有方式", { icon: 5, shift: 6 }, function () {
				});
				return false;
			}else if(qlrList.length > 1){	//如果权利人信息是多条，去判断共有情况和权利比例
				if(qlrList[0].gyfs == "2"){
					var total = 0;
					com.each(qlrList,function(key,tmp){
						if(com.trim(tmp.qlbl) == ""){
							users_qlr.scrollOn();
							layui.layer.msg(tmp.qlrmc + "的所占份额不可为空", { icon: 5, shift: 6 });
							flag = false;
						}else{
							total += parseInt(com.trim(tmp.qlbl));
						}
					})
					if(!flag) return false;
					if(total != 100){
						users_qlr.scrollOn();
						layui.layer.msg("按份共有占有份额总值应为100%", { icon: 5, shift: 6 });
						return false;
					}
				}
			}
			return {
				qlrList : JSON2.stringify(qlrList.concat(ywrList)),
				qlrDelList : JSON2.stringify(users_qlr.getDelList())
			}
		}
		if("showdetail" in window || ("process" in window && process.getIndex() != "3")){
    		com(".block-users").find("*").not("button.block-userInfo-media,button.block-userInfo-picture").attr("disabled","disabled");
    		com(".block-users").find(".userTemplateDelete").remove();
    		com(".block-users").find(".block-userInfo-adduser").remove();
    		com(".block-users").find(".block-userInfo-gyqk").find("lay-radio").off("click");
    		layui.form.render();
    	}
	}
	//初始化
	if(REC_ID){
		com.ajax({
			url : config["url"]["process-getUserDataListByID"],
			type : "POST",
			contentType: "application/json;charset=UTF-8",
			dataType : "JSON",
			data : JSON.stringify({
				ID : REC_ID
			}),
			load : true,
			success : function(rst){
				if(rst.code == "200"){
					initData(rst.data);
				}else{
					layui.layer.alert(rst.msg);
				}
			}
		})
	}else{
		init();
	}
	//表单的相关校验
	layui.form.verify({
        required: function (value, item) {
        	if (("process" in window && process.getIndex() != "4")) {
        		if (!/[\S]+/.test(value.trim())) {
        			return "必填项不能为空";
        		}
			}
        }
        , contactPhone: function (value, item) { /* 联系电话验证（座机或手机号） */
            if (!!value) {
            	globalutil.mobilePhoneRegex.lastIndex = 0;
                if (!globalutil.mobilePhoneRegex.test(value)) {
                    return "联系电话格式不正确！";
                }
            }
        }
        , personzjhm: function (value, item) {
            var idType = com(item).closest("tr").find('select[lay-transname="zjlx"]').next().find("dd.layui-this").attr("lay-value");
            if (!!value && idType == '1') {
                if (!globalutil.checkIdCard(value)) {
                    return "身份证号码格式不正确！";
                }
            }
        }
        , checkIDcard: function (value, item) {
            if (!!value) {
                if (!globalutil.checkIdCard(value)) {
                    return "身份证号码格式不正确！";  //
                }
            }
        }
        , checkSpecialStr: function (value, item) { /* 联系电话验证（座机或手机号） */
            if (!!value) {
                if (!new RegExp("^[a-zA-Z0-9_\u4e00-\u9fa5\\s·]+$").test(value)) {
                    return "不能有特殊字符";    //
                }
            }
        }
        , numeric: function (value, item) {
            if (!!value) {
                if (!new RegExp("^([1-9]\\d*|0)(\\.{0,1})(\\d*)$").test(value)) {
                    return "请填写正确的数值类型";    // 
                }
            }
        }
        , bdcdyh: function (value, item) {
            if (!!value) {
            	globalutil.bdcdyhRegex.lastIndex = 0;
                if (!globalutil.bdcdyhRegex.test(value)) {                  // 6位行政区划，3位地籍区，3位地籍子区，2位宗地特征码，5位宗地顺序号，1位定着物特征码，8位定着物单元编号
                    return "请填写28位不动产单元号，如：340824400002GB00121F00010039";      // 
                }
            }
        }
        , sfzh: function (value, item) {
            if (!!value) {
                if (!globalutil.getsexAndAgeData(value)) {                  
                    return "存在不具备完全民事行为能力的申请人，请至不动产大厅线下办理！"; 
                }
            }
        }
    })
	function UserInfo(opt){
		var that = this;
		this._data = opt;
		this._data["divid"] = globalutil.guid();
		this._data["size"] = 0;
		this._data["delObj"] = [];
		//加载模块框架
		layui.laytpl(userTemplate.innerHTML).render(opt, function(string) {
			com(".block-users").append(string);
			com("div.block-userInfo.block-userInfo-" + that._data["divid"] + " .userInfo-addUser").off().on("click",function(){
				var target = com("div.block-userInfo.block-userInfo-" + that._data["divid"] + " div.block-userInfo-body");
				var radio = com(target.children().get(0)).find("lay-radio[lay-transname]").find("div.layui-form-radioed").prev().val();
				if(radio == "0"){
					layui.layer.alert("若要添加新纪录，共有情况不可为【单独所有】，请修改后再进行添加操作！温馨提示：若是按份共有，请填写占有份额");
				}else{
					var checked = com(target.children().get(0)).find("div.layui-form-radioed").prev().val();
					com(target.children().get(0))
					.find("lay-radio[lay-transname]")
					.attr("lay-disabled","0")
					.attr("lay-checked",checked)
					.removeAttr("rendered");
					that.addUserItem({
						isCanDelete : true,
						GYFS : checked, 
						BZ : '0',
						disabled : {
							GYFS : 0
						}
					});
				}
			})
		});
		//加载模块中的人员项
		this.addUserItem = function(data){
			var target = com("div.block-userInfo.block-userInfo-" + that._data["divid"] + " div.block-userInfo-body");
			data["index"] = target.children().length;
			data["divid"] = that._data["divid"];
			layui.laytpl(userItemTemplate.innerHTML).render(data, function(string) {
				target.append(string);
				target.find(".block-userInfo-item .userTemplateDelete").off("click").on("click",function(){
					var qlrid = com(this).closest("div.block-userInfo-item").find('input[lay-transname="qlrid"]').val();
					if(qlrid != '') that._data["delObj"].push(qlrid);
					that._data["size"]--;
					com(this).closest("div.block-userInfo-item").remove();
					if(target.children().length == 1){
						com(target.children().get(0)).find("lay-radio[lay-transname]")
						.attr("lay-disabled","")
						.attr("lay-checked","0")
						.removeAttr("rendered");
						target.find("input[lay-transname='qlbl']").val("");
						globalutil.render(target);
					}
					
				});
				
				target.find("button.block-userInfo-media").off("click").on("click",function(){
					var url = com(this).attr("media-url");
					parent.layui.layer.open({
						title:false,
						type : 1,
						content : '<video autoplay style="width: 99%;height: 99%;" src="'+url+'" controls="controls">您的浏览器不支持 video 标签。</video>',
						area : ["85%","90%"]
					})
				});
				
				target.find("button.block-userInfo-picture").off("click").on("click",function(){
					var url = com(this).attr("pic-url");
					parent.layui.layer.open({
						title:false,
						type : 1,
						content : '<img src="'+url+'" style="position: absolute;left: 0;right: 0;top: 0;bottom: 0;margin: auto;max-width:80%;max-height:80%;"  />',
						area : ["80%","90%"]
					})
				});
			});
			
			if(data.BZ == "0"){
				var _layRadio = target.find(".block-userInfo-gyqk");
				_layRadio.find("lay-radio").off("click").on("click",function(){
					if(com(this).hasClass("lay-radio-exclude")){
						return true;
					}
					var radioed = com(this).find("div.layui-form-radioed").prev().val();
					if(radioed == 2){
						com(this).find("input[lay-transname='qlbl']").prop("disabled",false).removeClass("layui-disabled");
					}else{
						com(this).find("input[lay-transname='qlbl']").prop("disabled",true).addClass("layui-disabled").val("");
					}
					com(this).addClass("lay-radio-exclude");
					_layRadio.find("lay-radio").not(com(this)).find("input[type='radio'][value='"+radioed+"']").next().click();
					com(this).removeClass("lay-radio-exclude");
				});
			}
			
			globalutil.render(target);
			that._data["size"]++;
		};
		//获取单个模块的人员总数
		this.getSize = function(){
			return that._data["size"];
		};
		//获取单个模块的人员列表数据
		this.getDataList = function(){
			var target = com("div.block-userInfo.block-userInfo-" + that._data["divid"] + " div.block-userInfo-body"),
				children = target.children(),
				rows = [];
			for(var i = 0 ; i < children.length ; i++ ){
				var data = globalutil.transnames(children[i]);
				data["sxh"] = i;
				data["xh"] = i;
				data["rec_id"] = REC_ID;
				rows.push(data);
			}
			return rows;
		};
		this.getDelList = function(){
			return that._data["delObj"];
		};
		//页面滚动到模块
		this.scrollOn = function(){
			var target = com("div.block-userInfo.block-userInfo-" + that._data["divid"]);
			com("html,body").animate({scrollTop: target.offset().top - 76},500);
		};
	}
})