layui.use([ 'form', 'element', 'table' ], function() {
	var REC_ID = globalutil.GetQueryString("ID");
	var form = layui.form;
	var element = layui.element;
	var table = layui.table;
	
	form.render();
	
	table.render({
		url : config["url"]["process-getRxrzDataListByID"],
		elem: '#archiveTable',
		contentType: "application/json;charset=UTF-8",
		method: 'post',
		where : {
			ID : REC_ID,
			faceCheck : true
		},
		parseData:function(rst){//res 即为原始返回的数据
			if(rst.code == "200"){
				var flag = true;
				for(var i = 0 ; i < rst.data.length ; i++ ){
					if(rst.data[i]["RXRZZT"] != '1'){
						flag = false;
						break;
					}
				}
				if(flag) com(".select-faceCheckIdentity-next").show();
				return {
					code : 0,
					data : rst.data
				};
			}else{
				com("#select-faceCheckIdentity-box").hide();
				com("#select-faceCheckIdentity-errorMsg").html(rst.msg);
				return null;
			}
		},
		//page: true ,//开启分页
//		limit: 10,
		cols: [[
			{ field: 'BZMC', width: 110, align: 'center', title: '所属角色', templet: function (d) {
				return d.BZ == "0" ? "权利人" : "义务人";
			} },
			{ field: 'QLRMC', width: 230, align: 'center', title: '名称(单位)' },
			{ field: 'ZJLXMC', width: 200, align: 'center', title: '证件名称' },
			{ field: 'ZJHM', width: 230, align: 'center', title: '证件号码' },
			{ 
				field: 'cz', width: 182, align: 'center', title: '操作', templet: function (d) {
					if(d.RXRZZT == "1"){
						return '<a style="color:#ccc" >认证通过</a>'
					}else{
						return '<a class="select-faceCheckIdentity-selectDetail" style="cursor:pointer;color:#10c1ad;font-weight:bold;" qlrid='+d.QLRID+' >认证</a>'
					}
				}
			}
		]],
		done : function(data){
			initCheckButton();
		}
	});
	
	com(".select-faceCheckIdentity-prev").off().on("click",function(){
		layui.layer.confirm("返回上一步后实人认证状态将失效，确定继续操作？",function(index){
			layui.layer.close(index);
			com.ajax({
    			url : config["url"]["process-refreshRxrzzt"],
    			dataType : "json",
    			type : "post",
    			async : true,
    			data :  {ID: REC_ID},
    			success :function(result){
    				if(result.code == "200"){
    					layui.layer.msg('即将返回上一步操作', {offset: 'auto', time:1000},function(){
    						process.prev();
    					});
    				}else{
    					layui.layer.alert(result.msg);
    				}
    			}
    		});
		})
		
	})
	com(".select-faceCheckIdentity-next").off().on("click",function(){
		layui.layer.confirm("实人认证处理成功，是否要提交到不动产预审？",function(index){
			layui.layer.close(index);
			com.ajax({
    			url : config["url"]["showdetail-setCheckAuditing"],
    			dataType : "json",
    			contentType: "application/json;charset=UTF-8",
    			type : "post",
    			async : true,
    			load : true,
    			data :  JSON.stringify({ID: REC_ID, status : "1", psup : "yes"}),
    			success :function(result){
    				if(result.code == "200"){
    					layui.layer.msg('提交预审成功,即将返回用户中心', {offset: 'auto', time:1000},function(){
    						window.location.href = config["page"]["usercenter"];
    					});
    				}else{
    					layui.layer.alert(result.msg);
    				}
    			}
    		});
		})
	})
	
	function initCheckButton(){
		com(".select-faceCheckIdentity").next()
		.find("a.select-faceCheckIdentity-selectDetail").off("click").on("click",function(){
			var qlrid = com(this).attr("qlrid");
			var ewmlayerloadindex = layui.layer.load(2);
	        var qrcode = new QRCode("faceCheckByPhoneQrCode", {
	                text: window.location.origin + "${ContextPath}/ctrlGrsb/faceCheck?a="+qlrid,
	                width: 204,
	                height: 204,
	                colorDark: '#000',
	                colorLight: '#fff',
	                correctLevel: QRCode.CorrectLevel.H
	            });
//	        uploadservice.editPhoneScanFlag(JSON2.stringify({ flag: 1, code: uploadmodel.maincode }));
	        var ewmlayerindex = layui.layer.open({
	            type: 1
	            , title: false
	            , closeBtn: 0
	            , btn: ''
	            , resize: false
	            , zIndex: 100
	            , shade: [0.3, '#fff']
	            , area: ['320px']
	            , content: com('#scanToFaceCheckByPhoneWrap')
	            , success : function(){
	            	layui.layer.close(ewmlayerloadindex);
	            }
	        })
	        com("#endFaceCheckBtn").off("click").on("click",function(){
	        	window.location.reload();
	        })
//			qrcode.min.js
//			"/GRSB/common/nologin/uploadAffix.html";
		})
	}
	
	// 复制的方法
	function copyText(text, callback){ // text: 要复制的内容， callback: 回调
	    var tag = document.createElement('input');
	    tag.setAttribute('id', 'cp_hgz_input');
	    tag.value = text;
	    document.getElementsByTagName('body')[0].appendChild(tag);
	    document.getElementById('cp_hgz_input').select();
	    document.execCommand('copy');
	    document.getElementById('cp_hgz_input').remove();
	    if(callback) {callback(text)}
	}
});